# ui
# creates the user interface

proc ui { } {

wm title . {TE Tags}

frame .fr
frame .fr.mbar
pack .fr.mbar -side top -fill x


scrollbar .fr.yscroll -command {.fr.t yview}
text .fr.t -wrap word -width 80 -height 20 -bg white -yscrollcommand {.fr.yscroll set}
pack .fr -expand true -fill both
pack .fr.yscroll -side right -fill y
pack .fr.t -expand true -fill both


# For best results on your operating system, experiment with the 
# fonts, sizes and colours.
# stdfont is the standard font in the API window,
# tagfont is the font used for the tags

.fr.t tag configure stdfont -font {Helvetica 8}
.fr.t tag configure tagfont -font {Helvetica 4} -foreground yellow

}


# initialize
# sets target text variable

proc initialize { } {

global targetText

set targetText [gettarget]

instarget $targetText

formattags

return

}



# gettarget
# opens target text script file and
# returns its content
# edit sFile for actual location of target.txt

proc gettarget { } {

global targetText

set sFile "target.txt"

set sFileHan [open $sFile r]

fconfigure $sFileHan -encoding utf-8

set segLen [file size $sFile]

set targetText [read $sFileHan $segLen]

close $sFileHan

return $targetText

}


# inserts text into UI text field

proc instarget {targetText} {

.fr.t delete 1.0 end

.fr.t insert 1.0 $targetText

.fr.t tag add stdfont 1.0 end

}


# updatetarget
# retrieves target segment via gettarget
# inserts target segment in UI via instarget

# global targetText

proc updatetarget {oldtarget} {

set newtarget [gettarget]

if {$oldtarget == $newtarget} {

return

} else {

instarget $newtarget

formattags

	}

}


# listener
# every
# checks regularly for changes in target.txt
# (change in active OmegaT segment)

proc listener { } { 

global targetText

        every { updatetarget $targetText }    

}

proc every { command } {

global targetText

   eval $command

   after 500 [list every $command]

}



# formattags

proc formattags { } { 

set tagPat {\<.+?\>}

set startSearch {1.0}

set tagStart {0.0}

set tagEnd {0.0}



while { $tagStart != {} } {

set tagStart [.fr.t search -regexp -count cnt $tagPat $startSearch end]

if { $tagStart == {} } {

return 

} else {

set tagEnd "$tagStart +$cnt chars"

.fr.t tag add tagfont $tagStart $tagEnd

set startSearch $tagEnd

		}

	}

}





ui

initialize

listener

