# ui
# creates the user interface

proc ui { } {

wm title . {TE Warning}

frame .fr
frame .fr.mbar
pack .fr.mbar -side top -fill x

frame .fr.top
label .fr.top.label1 -text {Search for:}
entry .fr.top.entry1

pack .fr.top -side top -fill x
pack .fr.top.label1 -side left
pack .fr.top.entry1 -side left -fill x

scrollbar .fr.yscroll -command {.fr.t yview}
text .fr.t -wrap word -width 80 -height 20 -bg white -yscrollcommand {.fr.yscroll set}

pack .fr -expand true -fill both
pack .fr.yscroll -side right -fill y
pack .fr.t -expand true -fill both

}


# initialize
# sets source text variable

proc initialize { } {

global sourceText

set sourceText [getsource]

inssource $sourceText

return

}



# getsource
# opens source text script file and
# returns its content
# edit sFile for actual location of source.txt

proc getsource { } {

global sourceText

set sFile "source.txt"

set sFileHan [open $sFile r]

fconfigure $sFileHan -encoding utf-8

set segLen [file size $sFile]

set sourceText [read $sFileHan $segLen]

close $sFileHan

return $sourceText

}


# inserts text into UI text field
# (routine method)

proc inssource {sourceText} {

.fr.t delete 1.0 end

.fr.t insert 1.0 $sourceText

}


# updatesource
# retrieves source segment via getsource
# inserts source segment in UI via inssource

# global sourceText

proc updatesource {oldSource} {

set sourceText [getsource]

if {$oldSource == $sourceText} {

return

} else {

inssource $sourceText

segmentaction

	}

}


# listener
# every
# checks regularly for changes in source.txt
# (change in active OmegaT segment)

proc listener { } { 

global sourceText

        every { updatesource $sourceText }    

}

proc every { command } {

global sourceText

   eval $command

   after 500 [list every $command]

}

# segmentaction
# performs an action when a new segment is opened
# in this case, outputs a warning if the (source) 
# segment text contains the text in the entry field

proc segmentaction { } {

.fr.t tag configure hilite -background yellow

global sourceText

set entrytext1 [.fr.top.entry1 get]

set stringmatch "*$entrytext1*"

if { [string match $stringmatch $sourceText] == 1 } {

.fr.t delete 1.0 end

.fr.t insert 1.0 $sourceText 

.fr.t tag add hilite 1.0 end

# Audio warning: comment the next line to suppress

bell

	}

}


ui

initialize

listener

